> ## Documentation Index
> Fetch the complete documentation index at: https://docs.notifly.tech/llms.txt
> Use this file to discover all available pages before exploring further.

# Create catalog items in bulk

> Create up to 50 new items per request.



## OpenAPI

````yaml /en/api-reference/openapi.yaml post /v1/projects/{projectId}/catalogs/{catalogName}/items
openapi: 3.0.3
info:
  title: Notifly API
  version: 1.0.0
  contact:
    email: contact@notifly.tech
servers:
  - url: https://api.notifly.tech
    description: Notifly API server
security: []
tags:
  - name: catalog
    x-group: Catalogs
paths:
  /v1/projects/{projectId}/catalogs/{catalogName}/items:
    parameters:
      - $ref: '#/components/parameters/ProjectId'
      - name: catalogName
        in: path
        description: Unique name supplied when the catalog was created.
        required: true
        schema:
          type: string
          pattern: ^[A-Za-z0-9_-]+$
          maxLength: 250
    post:
      tags:
        - catalog
      summary: create-api-catalog-items
      description: Create up to 50 new items per request.
      operationId: createApiCatalogItems
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CatalogBulkItemWriteRequest'
      responses:
        '200':
          description: Completed
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CatalogEmptyResponse'
        '400':
          $ref: '#/components/responses/CatalogBadRequest'
        '401':
          $ref: '#/components/responses/CatalogUnauthenticated'
        '403':
          $ref: '#/components/responses/CatalogPermissionDenied'
        '404':
          $ref: '#/components/responses/CatalogNotFound'
        '409':
          $ref: '#/components/responses/CatalogConflict'
        '413':
          $ref: '#/components/responses/CatalogPayloadTooLarge'
        '500':
          $ref: '#/components/responses/CatalogInternalServerError'
      security:
        - bearerAuth: []
components:
  parameters:
    ProjectId:
      name: projectId
      in: path
      description: Notifly project ID.
      required: true
      schema:
        type: string
        pattern: ^[a-f0-9]{32}$
        minLength: 32
        maxLength: 32
  schemas:
    CatalogBulkItemWriteRequest:
      type: object
      additionalProperties: false
      required:
        - items
      properties:
        items:
          type: array
          minItems: 1
          maxItems: 50
          description: Item IDs must be unique within a request.
          items:
            $ref: '#/components/schemas/CatalogItem'
      example:
        items:
          - id: sku-001
            name: 에브리데이 백팩
            price: 59000
            tags:
              - bag
              - new
    CatalogEmptyResponse:
      type: object
      required:
        - data
        - error
      properties:
        data:
          nullable: true
          enum:
            - null
        error:
          nullable: true
          enum:
            - null
      example:
        data: null
        error: null
    CatalogItem:
      type: object
      description: >-
        A catalog item that you manage. Notifly returns values as stored,
        without classifying or masking them. Keep personal names, email
        addresses, phone numbers, external user IDs, profile fields, and other
        identifying values out of the catalog.
      required:
        - id
      properties:
        id:
          type: string
          pattern: ^[A-Za-z0-9_-]+$
          maxLength: 250
      additionalProperties:
        $ref: '#/components/schemas/CatalogJsonValue'
    CatalogApiErrorResponse:
      type: object
      required:
        - data
        - error
      properties:
        data:
          nullable: true
          enum:
            - null
        error:
          $ref: '#/components/schemas/CatalogApiError'
      example:
        data: null
        error:
          code: INVALID_ARGUMENT
          message: Invalid bulk item request.
          details:
            - field: items[0].unknown_field
              path:
                - items
                - 0
                - unknown_field
              code: invalid-fields
              message: 'Unrecognized field: unknown_field.'
    CatalogJsonValue:
      description: >-
        A recursive JSON value for a catalog item field. A string can contain up
        to 5,000 characters, an array can hold up to 100 entries, and objects
        and arrays can nest up to 50 levels.
      oneOf:
        - type: string
          maxLength: 5000
        - type: number
        - type: boolean
        - nullable: true
          enum:
            - null
        - type: array
          maxItems: 100
          items:
            $ref: '#/components/schemas/CatalogJsonValue'
        - type: object
          additionalProperties:
            $ref: '#/components/schemas/CatalogJsonValue'
          description: >-
            Stored object keys cannot contain periods or dollar signs. Use
            `$add` and `$remove` only as operators to `PATCH` an array field.
    CatalogApiError:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: string
        message:
          type: string
        details:
          type: array
          description: >-
            Identifies fields and paths where validation failed. Use these
            structured fields in clients.
          items:
            $ref: '#/components/schemas/CatalogApiValidationErrorDetail'
      additionalProperties: true
    CatalogApiValidationErrorDetail:
      type: object
      description: >-
        One validation error. The `field` value is a human-readable path with
        dots and brackets. The `path` value represents the same location as an
        array of strings and numbers.
      required:
        - field
        - path
        - code
        - message
      properties:
        field:
          type: string
          description: >-
            Field path in dot and bracket notation, for example
            `items[0].price`.
        path:
          type: array
          description: Field path as an array of string and number segments.
          items:
            anyOf:
              - type: string
              - type: integer
        code:
          type: string
          description: Code that identifies why the input was rejected.
        message:
          type: string
          description: Human-readable validation error message.
      additionalProperties: false
  responses:
    CatalogBadRequest:
      description: Invalid Catalog request.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CatalogApiErrorResponse'
    CatalogUnauthenticated:
      description: Authentication required.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CatalogApiErrorResponse'
    CatalogPermissionDenied:
      description: Project access denied.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CatalogApiErrorResponse'
    CatalogNotFound:
      description: Catalog resource not found.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CatalogApiErrorResponse'
    CatalogConflict:
      description: Catalog resource already exists.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CatalogApiErrorResponse'
    CatalogPayloadTooLarge:
      description: JSON body exceeds 4 MiB.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CatalogApiErrorResponse'
    CatalogInternalServerError:
      description: Internal server error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CatalogApiErrorResponse'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT
      description: Pass the token issued by `POST /authenticate` as a bearer token.

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.